package org.ow2.jonas.cxf.transport.reliablejms.test.springmdp.impl;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

public class Servlet extends HttpServlet {

	private static final long serialVersionUID = 1L;

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {

		ApplicationContext appContext = WebApplicationContextUtils
				.getWebApplicationContext(getServletContext());
		if (appContext == null) {
			throw new IllegalStateException("Failed to load webapp spring application context");
		}

		PrintWriter out = response.getWriter();
		String requestedAction = request.getParameter("action");

		RemoteTester rt = (RemoteTester) appContext.getBean("remoteTester");

		if ("init".equals(requestedAction)) {
			rt.init();
		} else if ("callWS".equals(requestedAction)) {
			try {
				rt.callWS();
			} catch (Exception e) {
				throw new ServletException(e);
			}
		} else if ("callWSThenThrowRuntime".equals(requestedAction)) {
			try {
				rt.callWSThenThrowRuntime();
			} catch (Exception e) {
				// Expected in the test scenario
			}
		} else if ("getCalls".equals(requestedAction)) {
			out.print(rt.getCalls());
		} else if ("getNotifiedCalls".equals(requestedAction)) {
			out.print(rt.getNotifiedCalls());
		} else if ("checkExpectedErrors".equals(requestedAction)) {
			rt.checkExpectedErrors();
		} else if ("checkExpectedValues".equals(requestedAction)) {
			rt.checkExpectedValues();
		}

	}
}
