package org.ow2.jonas.cxf.transport.reliablejms.test.springmdp.impl;

import org.ow2.jonas.cxf.transport.reliablejms.api.AsyncHandler;
import org.ow2.jonas.cxf.transport.reliablejms.api.ContextInfo;



public class TestAsyncHandler implements AsyncHandler {

    private Checker checker = null;
    
    
    public TestAsyncHandler()  {
    }
    
	public void setChecker(Checker c) {
		checker = c;
	}
    
    public void doHandlerFault(Throwable exception, ContextInfo contextInfo) {
 //   	System.err.println("----- TRACE ----- : doHandlerFault : " + contextInfo.getWsdlOperation().getLocalPart());
        checker.handleFault(contextInfo, exception);        
    }

    public void doHandlerResponse(Object response, ContextInfo contextInfo) {
//    	System.err.println("----- TRACE ----- : doHandlerResponse : " + contextInfo.getWsdlOperation().getLocalPart());
        checker.handleResponse(contextInfo, response);        
    }

    public boolean doYouKnowThisContext(ContextInfo contextInfo) {
        if (checker.isKnownContext(contextInfo)) {
            return true;
        }
        // invalid answer !
        checker.replyWithoutCall(contextInfo);
        return false;
    }

    public void saveContext(ContextInfo contextInfo) {
        // This web service has been called
        checker.addCall(contextInfo);
    }

}
